# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import platform
import bs4 as BeautifulSoup
import win32api

# Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
bin_contains = "Poedit-"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://poedit.net/download"

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all('https://poedit.net/download', "a","class","btn btn-secondary w5", proxies=proxies):
        if bin_contains in bs_search["href"]:
            url_dl = bs_search["href"]
            latest_bin = url_dl.split("/")[-1]
            version = latest_bin.split("-")[-2]
            break

    #print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    control.version = "%s-%s" % (Version(get_file_properties(latest_bin)["FileVersion"]), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating or not update-package-sources
    return result
